﻿// www.d54x.ru 
// Programs Qt C++  prog2_05
// Bezpodnykh I.P.  
////////////////////////////////////////


#include <QtCore>        // консольное окно
#include <QTextEdit>     // для ред. текста
#include <QTextStream>   // для раб. с текстом
#include <conio.h>       // kbhit,   getch
#include <stdio.h>       // fopen,   printf 
#include <qmath.h>       // pow,     sqrt 
#include<iostream>       // cout,    cin


// Объявляем рабочее пространство имен std
  using namespace std;



/////////////////////////////////////////////////////////////////////////////////////
// Вся оперативная память компьютера пронумерована
// номер ячейки памяти - этот адрес этой ячейки памяти.
// Указатель - зто переменная, которая содержит адрес другой переменной.
// К переменной  можно обращаться по имени или по ее адресу.
// Если известно имя можно получить адрес, используя символ "&" перед переменной
// Если известен адрес можно получить имя, используя операцию разыменования "*"

// Пример объявления указателя на строку символов:
// char *p;  здесь "p" - это указатель (адрес строки)

// объявим массив символов (строку) и инициализируем 
// char array[]="Дорогу осилит идущий";

// p = &array;  теперь  "р" содержит адрес начала массива array

// Объявим два символа
// char  cha, chb;


// Используем операцию разыменования "*"  для получения  значения  по адресу

// Инициализируем переменную  "cha"  буквой "Д" здесь "p" - это указатель на строку
// cha = *p;  или можно  так         cha = p[0];  

// Инициализируем переменную  "chb"  буквой "л"
// chb = *(p + 10);  или можно так   chb = p[10];  

// Если сделаем так, (по адресу p + 5 запишем символ "и")
// *(p + 5) = 'и';
// то мы превратим строку "Дорогу осилит идущий" в строку "Дороги осилит идущий"

// Вывод строки на экран можно сделать так:
// cout << p ;
//----------------------------------------------------------------------------------

 
// Структура это расширенное понятие массива
// Структура создается с помощью ключевого слова "struct".
// В отличии от массива, в структуре могут находиться данные любого типа
// и не только данные, но и функции (методы).
// Все данные и функции в структуре по умолчанию являются доступными (public:)
// В конце определения структуры обязательно ставится точка с запятой.
// Структура представляет собой новый тип данных созданных пользователем
// Имя типу данных вы даете сами (в нашем случае это "Student")
// Зная имя типа данных, вы создаете переменные этого типа
// их еще называют объектами или экземплярами структуры.
// Доступ к полям структуры осуществляется через оператор прямого доступа - точку
// или оператор косвенного доступа - стрелку (если используется указатель)
////////////////////////////////////////////////////////////////////////////////////


//Объявим структуру;
  struct Student{
                 char name[40];
                 int  curs;
                 int  god;
                 };

  // Объявим экземпляр структуры и инициализируем его
  Student      a =  { "Biliams",  4,  1984  };

  // Создадим указатель на экземпляр структуры
  // Точнее, создадим указатель на структуру "Student" 
  // и инициализируем его адресом экземпляра "a" структуры  "Student"
   
  Student *d=&a;
 
int main()
  {
      QTextStream cin(stdin); cin.setCodec("CP866");     // кодировка DOS
       QTextStream cout(stdout); cout.setCodec("CP866");  // кодировка DOS
       cout << QString::fromUtf8("  Выведем на экран поля структуры через оператор прямого доступа [.] ") <<endl;   // вывод строки

  
    


  // Выведем на экран через оператор прямого доступа 
  cout << a.name << endl;
  cout << a.curs << endl;
  cout << a.god  << endl;
 
  cout << endl;


  cout << QString::fromUtf8("   Выведем на экран поля структуры через оператор косвенного доступа [->] ") <<endl;   // вывод строки


  // Выведем на экран через оператор косвенного доступа ->
  cout << d->name << endl;
  cout << d->curs << endl;
  cout << d->god  << endl;


  // Ждем ввода любого символа
  char  ch;
  cin >>ch;
                
 } 
   
