#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include "GLWidget.h"

namespace Ui
{
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

private:
    Ui::MainWindow *ui;
    MyGLWidget *GLW;

private slots:
    void on_actionLoad_activated();
    void on_actionSave_activated();
    void on_actionNew_activated();
    void on_actionAbout_activated();
    void on_actionAuthor_activated();
    void on_actionAbout_Qt_activated();
    void on_actionSave_Image_activated();
};

#endif // MAINWINDOW_H
