 
// www.d54x.ru 
// Programs Qt C++  prog3_10
// Bezpodnykh I.P.  
////////////////////////////////////////

#pragma once 
#include <QtCore>        // консольное окно
#include <QTextEdit>     // для ред. текста
#include <QTextStream>   // для раб. с текстом
#include <conio.h>       // kbhit,   getch
#include <stdio.h>       // fopen,   printf 
#include <qmath.h>       // pow,     sqrt 
#include<iostream>       // cout,    cin
#include <vector>        // vector<>
#include <algorithm>     // sort

// Объявляем рабочее пространство имен std
  using namespace std;

// Стандартная библиотека шаблонов (STL - Standard Template Library) - эта
// библиотека контейнерных классов, которая включает векторы, списки, очереди и стеки,
// а также ряд алгоритмов общего назначения. Использование  STL в прикладных программых
// поможет программисту создать более компактный код и ориентироваться на проблему,
// поставленную перед прикладной программой, а не задумываться над вопросами реализации
// способов хранения данных и обеспечения доступа к ним. 
// Контейнер - это объект, который предназначен для хранения других объектов.
// STL - предствляет два типа кантейнера: Последовательные и ассоциативные
// Итераторы играют роль указателя на элементы контейнера и позволяют осуществлять
// навигацию по их элементам.
// Вектор   -  это контейнерный класс, в котором доступ к его элементам 
// осуществляется по индексу.



int main()
{
// Объявим вектор и инициализируем его
   vector<char*>  v;
   
   v.push_back("Cokolov  B.B.");
   v.push_back("Basarnow O.I.");
   v.push_back("Scrabin  G.G.");
   v.push_back("Turpanov A.I.");
   v.push_back("Koslov   V.A.");
   v.push_back("Safer    U.G.");

   cout<< v.size() <<endl;

   vector<char*>::iterator   p;
   p=v.begin();
   
   while(p!=v.end())
   {
	   cout<< *p << endl;
	   p++;
   }

   cout <<"-------------------"<< endl;

// Можно было и так!
  for(p=v.begin(); p < v.end(); p++)
   {
	   cout<< *p << endl;
	   
   }


  cout <<"==================="<< endl;

// Можно было и так!
  p=v.begin();

  for(int i=0; i < v.size(); i++)
   {
	   cout<< p[i] << endl;
	   
   }


//  Ждем ввода любого символа
   char  ch;	 cin >> ch ;                  
}




